SystemOrganization addCategory: #Folktale!


Object subclass: #Folktale
	instanceVariableNames: 'isRunning listener '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Folktale'!

Object subclass: #FolktaleAgent
	instanceVariableNames: 'stream bindings history isRunning isChunk model '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Folktale'!

Folktale class
	instanceVariableNames: 'startUpServer '!

FolktaleAgent class
	instanceVariableNames: ''!


!Folktale commentStamp: 'tak 5/3/2004 01:47' prior: 0!
Folktale - a simple Squeak remote controller

Folktale openLauncher.
Folktale new start inspect.

$ telnet localhost 4919

or try with emacs
(defun squeak ()
  (interactive)
  (make-comint "squeak" '("localhost" . 4919))
  (pop-to-buffer "*squeak*"))

SARPackageDumper fileOutPackage: (PackageInfo named: 'Folktale') as: 'Folktale.sar'.
(PackageInfo named: 'Folktale') fileOut



!

!Behavior methodsFor: '*folktale' stamp: 'tak 5/2/2004 23:39'!
>>> aSymbol 
	^ String
		streamContents: [:aStream | self
				printMethodChunk: aSymbol
				withPreamble: true
				on: aStream
				moveSource: false
				toFile: 0]! !

!MethodReference methodsFor: '*folktale' stamp: 'tak 5/3/2004 23:51'!
asFileOutRefString
	^ classSymbol asString
		, (classIsMeta
				ifTrue: [' class']
				ifFalse: ['']) , ' >>> ' , methodSymbol printString! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 16:46'!
at: index
	^ history at: index! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/2/2004 14:23'!
back
	history size > 1
		ifTrue: [history removeLast].
	^ history last.! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 03:39'!
bannerString
	^ '** Welcome to Squeak
** VM: ' , Smalltalk platformName asString , '
**  - ' , Smalltalk vmVersion asString , '
** Image: ' , Smalltalk version asString , ' [' , Smalltalk lastUpdateString asString , ']'! !

!FolktaleAgent methodsFor: 'binding' stamp: 'tak 5/2/2004 13:22'!
bindingOf: aString 
	^ (self pseudoVars includes: aString)
		ifTrue: [aString -> (self perform: aString asSymbol)]
		ifFalse: [(bindings includesKey: aString)
				ifFalse: [bindings at: aString put: nil].
			bindings associationAt: aString]! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 16:40'!
bindings
	^ bindings! !

!Inspector methodsFor: '*folktale' stamp: 'tak 5/3/2004 11:22'!
briefDumpOn: aStream 
	aStream nextPutAll: object asOop asString, ': ', object defaultLabelForInspector;
		 cr.
	aStream nextPutAll: '====================';
		 cr.
	self fieldListForPrint
		keysAndValuesDo: [:index :value | 
			aStream nextPutAll: value , ' :'.
			aStream tab.
			aStream nextPutAll: ((self contentsAt: index)
					printStringLimitedTo: 80) withSeparatorsCompacted.
			aStream cr]! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 10:29'!
chat
	isChunk _ false! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 02:26'!
chunk
	isChunk _ true.
	self show: 'Now you are in chunk mode.'.
	self show: 'Say ''q!!'' when you come back.'.! !

!DictionaryInspector methodsFor: '*folktale' stamp: 'tak 5/2/2004 16:05'!
contentsAt: index
	^ object at: (keyArray at: index)
! !

!Inspector methodsFor: '*folktale' stamp: 'tak 5/2/2004 16:03'!
contentsAt: index 
	^ object instVarAt: index! !

!OrderedCollectionInspector methodsFor: '*folktale' stamp: 'tak 5/2/2004 16:22'!
contentsAt: index 
	^ object at: index! !

!Folktale methodsFor: 'accessing' stamp: 'tak 5/2/2004 10:13'!
defaultPort
	^ 4919! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 12:08'!
exit
	self stop.
	self show: 'bye!!'! !

!DictionaryInspector methodsFor: '*folktale' stamp: 'tak 5/2/2004 16:02'!
fieldListForPrint
	^ self fieldList
! !

!Inspector methodsFor: '*folktale' stamp: 'tak 5/2/2004 15:54'!
fieldListForPrint
	^ self fieldList allButFirst: 2
! !

!OrderedCollectionInspector methodsFor: '*folktale' stamp: 'tak 5/2/2004 16:21'!
fieldListForPrint
	^ (1 to: object size) collect: [:each | each asString]
! !

!ClassDescription methodsFor: '*folktale' stamp: 'tak 5/2/2004 03:16'!
fileOutString
	^String streamContents: [ :aStream |
		self fileOutOn: aStream]! !

!Folktale methodsFor: 'private' stamp: 'tak 5/3/2004 10:17'!
handle: socket 
	| aStream |
	[aStream _ SocketStream on: socket.
	(aStream respondsTo: #noTimeout)
		ifTrue: [aStream noTimeout].
	(FolktaleAgent on: aStream) mainLoop]
		ensure: [aStream isConnected
				ifTrue: [aStream close]]! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 23:40'!
help
	^ '
Useful expressions and pseudo variables.
Jump result object unless your query has dot(.) at end.
----
help -- This message.
exit  -- Exit.
self -- Current object.
ii -- Inspect self.
history -- Show history.
back -- Back.

q -- The agent (me).
q usefulExpressions -- Show more useful expressions.
'! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/2/2004 21:23'!
history
	^ history! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/2/2004 17:04'!
ii
	self show: self object inspectPrint! !

!FolktaleAgent methodsFor: 'browsing' stamp: 'tak 5/2/2004 23:55'!
implements: selector
	^ (Smalltalk allImplementorsOf: selector)
		collect: [:each | each asFileOutRefString]! !

!Folktale class methodsFor: 'class initialization' stamp: 'tak 5/3/2004 14:11'!
initialize
	"self initialize"
	Socket initializeNetwork.
	Smalltalk addToStartUpList: self after: nil.
	self runAtStartUp: true.! !

!FolktaleAgent methodsFor: 'initialize' stamp: 'tak 5/3/2004 02:25'!
initialize
	history _ OrderedCollection new.
	bindings _ Dictionary new.
	isChunk _ false.
	history addLast: self.! !

!Object methodsFor: '*folktale' stamp: 'tak 5/2/2004 16:35'!
inspectPrint
	^ Inspector inspectPrint: self! !

!Inspector class methodsFor: '*folktale' stamp: 'tak 5/2/2004 16:36'!
inspectPrint: anObject 
	| inspector |
	inspector _ ((anObject isKindOf: Dictionary)
				ifTrue: [DictionaryInspector]
				ifFalse: [(anObject isKindOf: OrderedCollection)
						ifTrue: [OrderedCollectionInspector]
						ifFalse: [Inspector]]) new.
	inspector inspect: anObject.
	^ String
		streamContents: [:aStream | inspector briefDumpOn: aStream]! !

!Folktale methodsFor: 'accessing' stamp: 'tak 5/2/2004 09:57'!
isRunning
	^ isRunning
		and: [listener notNil
				and: [listener isWaitingForConnection]]! !

!Folktale methodsFor: 'accessing' stamp: 'tak 5/3/2004 23:44'!
isSecure
	^ true! !

!Folktale methodsFor: 'private' stamp: 'tak 5/3/2004 23:53'!
listen
	| socket |
	socket _ (listener respondsTo: #waitForAcceptFor:)
				ifTrue: [listener waitForAcceptFor: 600]
				ifFalse: [listener
						waitForAcceptUntil: (Socket deadlineSecs: 300)].
	(self isSecure
			and: [socket notNil
					and: [socket remoteAddress ~= #(127 0 0 1 ) asByteArray]])
		ifTrue: [socket closeAndDestroy.
			^ nil].
	^ socket! !

!Folktale methodsFor: 'private' stamp: 'tak 5/3/2004 10:09'!
listenLoop
	| socket |
	[self isRunning]
		whileTrue: [[socket _ self listen.
			(socket notNil
					and: [socket isConnected])
				ifTrue: [[self handle: socket] fork]]
				on: ConnectionTimedOut
				do: []]! !

!FolktaleAgent methodsFor: 'loop' stamp: 'tak 5/3/2004 12:09'!
mainLoop
	isRunning _ true.
	self show: self bannerString.
	[isRunning]
		whileTrue: [isChunk
				ifTrue: [self readChunk]
				ifFalse: [self readEvalPrint]].
	self stop.! !

!FolktaleAgent methodsFor: 'browsing' stamp: 'tak 5/3/2004 11:14'!
methods: aClass 
	^ (aClass selectors
		collect: [:each | (MethodReference new setStandardClass: aClass methodSymbol: each) asFileOutRefString]) asSortedCollection! !

!FolktaleAgent class methodsFor: 'instance creation' stamp: 'tak 5/2/2004 13:22'!
new
	^ super new initialize! !

!Folktale methodsFor: 'private' stamp: 'tak 5/2/2004 10:17'!
newListenerOn: portNumber
	listener _ Socket newTCP.
	listener listenOn: portNumber backlogSize: 10.
	^ listener! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/4/2004 00:10'!
nextChunk
	| in source char |
	source _ ''.
	[source notEmpty
		and: [source last = $!!]]
		whileFalse: [source _ source , String crlf , self nextLine].
	in _ source readStream.
	in skipSeparators.
	^ String
		streamContents: [:aStream | 
			[in atEnd]
				whileFalse: [char _ in next.
					char = Character lf
						ifFalse: [aStream nextPut: char]].
			nil]! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/3/2004 23:13'!
nextLine
	| line |
	[(line _ [stream nextLine]
				on: Error
				do: [:ex | ex messageText = 'getData timeout'
						ifFalse: [^ ex signal]]) notNil] whileFalse.
	^ line! !

!FolktaleAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
notify: aString at: anInteger in: aStream 
! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 14:35'!
object
	^ history last! !

!FolktaleAgent class methodsFor: 'instance creation' stamp: 'tak 5/2/2004 00:33'!
on: aSocketStream
	^ self new stream: aSocketStream! !

!Folktale class methodsFor: 'accessing' stamp: 'tak 5/2/2004 19:49'!
openLauncher
	"self openLauncher"
	| button |
	button _ UpdatingSimpleButtonMorph new.
	button target: self.
	button actionSelector: #toggleRunAtStartUp.
	button wordingSelector: #statusStringForButton.
	button openInHand.! !

!Folktale methodsFor: 'printing' stamp: 'tak 5/2/2004 12:15'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' [' , self statusString , ']'! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 16:52'!
printOn: aStream
	aStream nextPutAll: 'Mr.Q'! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 23:30'!
ps
	| isActive |
	isActive _ (Process canUnderstand: #isTerminated)
				ifTrue: [[:proc | proc isTerminated]]
				ifFalse: [[:proc | proc suspendedContext isNil
						and: [proc ~~ Processor activeProcess]]].
	^ Process allSubInstances
		reject: [:each | isActive value: each]! !

!FolktaleAgent methodsFor: 'binding' stamp: 'tak 5/2/2004 17:06'!
pseudoVars
	^ #(#help #ii #q #back #history #exit )! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 21:24'!
push: anObject 
	(history last == anObject
			or: ["anObject == history" false
					or: [anObject == self
							or: [anObject isNil]]])
		ifFalse: [history addLast: anObject]! !

!FolktaleAgent methodsFor: 'binding' stamp: 'tak 5/2/2004 14:16'!
q
	^ self! !

!FolktaleAgent methodsFor: 'loop' stamp: 'tak 5/4/2004 00:13'!
readChunk
	| chunk |
	chunk _ self nextChunk.
	chunk isEmpty
		ifTrue: [^ self].
	chunk withBlanksCondensed = 'q!!'
		ifTrue: [self chat]
		ifFalse: [chunk first = $!!
				ifTrue: [chunk _ chunk, String cr , self nextChunk].
			self
				show: ([chunk readStream fileInAnnouncing: 'Loading']
						on: Error
						do: [:ex | ex signal])]! !

!FolktaleAgent methodsFor: 'loop' stamp: 'tak 5/3/2004 23:56'!
readEvalPrint
	| line answer |
	line _ self request: '> '.
	(line notNil
			and: [line notEmpty])
		ifTrue: [answer _ [Compiler
						evaluate: line
						for: self object
						notifying: self
						logged: false]
						on: Error
						do: [:ex | "signalerContext contextStack"
							ex].
			self show: answer.
			line last = $.
				ifFalse: [self push: answer]]! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/3/2004 10:09'!
request: prompt 
	| line |
	line _ nil.
	[stream nextPutAll: prompt;
		 flush.
	[line isNil]
		whileTrue: [line _ [stream nextLine]
						on: Error
						do: [:ex | (ex class = ConnectionTimedOut
									or: [ex messageText = 'getData timeout'])
								ifFalse: [ex signal]]].
	^ line]
		on: Error
		do: [:ex | (ex class = ConnectionClosed
					or: [ex messageText = 'a primitive has failed'])
				ifFalse: [ex signal]].
	^ self exit! !

!Folktale class methodsFor: 'accessing' stamp: 'tak 5/2/2004 19:48'!
runAtStartUp
	^ startUpServer notNil
! !

!Folktale class methodsFor: 'accessing' stamp: 'tak 5/2/2004 19:51'!
runAtStartUp: aBoolean 
	startUpServer
		ifNotNil: [startUpServer stop].
	aBoolean
		ifTrue: [startUpServer _ self new start]
		ifFalse: [startUpServer _ nil]! !

!FolktaleAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
select
	"hack"
	^ Error signal! !

!FolktaleAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
selectFrom: start to: stop
	"hack"! !

!FolktaleAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
selectionInterval
	"hack"
	^ 0 to: 0! !

!FolktaleAgent methodsFor: 'browsing' stamp: 'tak 5/3/2004 00:20'!
senders: selector
	^ (Smalltalk allCallsOn: selector)
		collect: [:each | each asFileOutRefString]! !

!Folktale class methodsFor: 'accessing' stamp: 'tak 5/2/2004 12:08'!
services
	"self services inspect"
	^ self allInstances select: [:each | each isRunning]! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 11:56'!
setTranscript: aBoolean 
	aBoolean
		ifTrue: [Transcript addDependent: self.
			model := Transcript]
		ifFalse: [Transcript removeDependent: self.
			model := nil]! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 21:20'!
show: anObject 
	| source next string |
	string _ self showString: anObject.
	source _ ((string respondsTo: #convertToSystemString)
				ifTrue: [string convertToSystemString]
				ifFalse: [string]) readStream.
	[[source atEnd]
		whileFalse: [next _ source next.
			next = Character cr
				ifTrue: [stream nextPutAll: String crlf]
				ifFalse: [stream nextPut: next]].
	stream nextPutAll: String crlf.
	stream flush]
		on: Error
		do: [:ex | (ex class = ConnectionClosed
					or: [ex messageText = 'a primitive has failed'])
				ifFalse: [ex signal]]! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 22:06'!
showString: anObject 
	anObject isText
		ifTrue: [^ anObject string].
	anObject isString
		ifTrue: [^ anObject].
	(anObject isKindOf: OrderedCollection)
		ifTrue: [^ anObject inspectPrint].
	(anObject isKindOf: Array)
		ifTrue: [^ anObject inspectPrint].
	(anObject isKindOf: Dictionary)
		ifTrue: [^ anObject inspectPrint].
	anObject isNumber
		ifTrue: [^ anObject asString]
		ifFalse: [^ anObject printString]! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 14:03'!
stack
	(self object isKindOf: Process) ifTrue: [
		^ self object suspendedContext contextStack].
	self show: 'Under constraction'.
[
	(self object isKindOf: Exception) ifTrue: [^self object signalerContext contextStack].
	self show: 'This message assumes you are in Exception object'
]! !

!Folktale methodsFor: 'actions' stamp: 'tak 5/2/2004 10:20'!
start
	self startOn: self defaultPort! !

!Folktale methodsFor: 'actions' stamp: 'tak 5/2/2004 19:30'!
startOn: portNumber 
	isRunning _ true.
	listener _ self newListenerOn: portNumber.
	[[self listenLoop]
		ensure: [isRunning _ false.
			listener
				ifNotNil: [listener closeAndDestroy]]] fork! !

!Folktale class methodsFor: 'class initialization' stamp: 'tak 5/3/2004 01:46'!
startUp
	FolktaleAgent
		allInstancesDo: [:each | each stop].
	self services
		do: [:each | each stop].
	startUpServer
		ifNotNil: [startUpServer start]! !

!Folktale methodsFor: 'accessing' stamp: 'tak 5/2/2004 09:53'!
statusString
	^ isRunning
		ifTrue: [listener
				ifNotNil: [listener statusString]]
		ifFalse: ['stop']! !

!Folktale class methodsFor: 'accessing' stamp: 'tak 5/2/2004 19:45'!
statusStringForButton
	^ String
		streamContents: [:aStream | 
			aStream nextPutAll: self name.
			aStream
				nextPutAll: (startUpServer
						ifNil: [' [stop]']
						ifNotNil: [' [running]'])]! !

!Folktale methodsFor: 'accessing' stamp: 'tak 5/2/2004 19:42'!
statusStringForButton
	^ self class name, self statusString
! !

!Folktale methodsFor: 'actions' stamp: 'tak 5/1/2004 21:27'!
stop
"OK"
	isRunning _ false! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 12:08'!
stop
	isRunning _ false.
	self setTranscript: false.
! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 14:19'!
stream
	^ stream! !

!FolktaleAgent methodsFor: 'accessing' stamp: 'tak 5/2/2004 00:30'!
stream: aSocketStream
	stream _ aSocketStream! !

!FolktaleAgent methodsFor: 'error handling' stamp: 'tak 5/2/2004 00:32'!
text
	^ '' asText! !

!Folktale class methodsFor: 'accessing' stamp: 'tak 5/2/2004 19:50'!
toggleRunAtStartUp
	self runAtStartUp
		ifTrue: [self runAtStartUp: false]
		ifFalse: [self runAtStartUp: true]! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 11:56'!
update: anObject 
	anObject == #appendEntry
		ifTrue: [model
				ifNotNil: [self show: model contents]]! !

!FolktaleAgent methodsFor: 'actions' stamp: 'tak 5/3/2004 14:05'!
usefulExpressions
	^ self show: '
Useful expressions
----
q chunk -- Go to chunk (GNU Smalltalk like) mode.
q!!  -- Back to chat mode.
q ps -- Process list.
q stack -- Show last stack.
q implements: #hash.
q senders: #hash.
q methods: Number.
q at: index -- Get an object in history.
q bindings  -- Local variables.
q setTranscript: true -- Attach transcript to this session.
q stream  -- input/output stream.

Smalltalk saveSession.
Smalltalk saveAsNewVersion.
'! !
Folktale initialize!
